#include "Highscore.h"

#include <vector>
#include "core/CoreIncludes.h"
#include "core/config/ConfigValueIncludes.h"
#include "core/singleton/ScopedSingletonIncludes.h"

namespace orxonox
{

    ManageScopedSingleton(Highscore, ScopeID::ROOT, false);
	RegisterClassNoArgs(Highscore);

	Highscore::Highscore()
    {
        RegisterObject(Highscore);
        this->setConfigValues();
    }

    void Highscore::setConfigValues()
    {
        SetConfigValue(highscores_, std::vector<std::string>()).description("HighscoreVektor");
    }

    int Highscore::getHighestScoreOfGame(std::string game){
        std::string delimiter = "./.";
        int best = -1;
        for (std::string score : this->highscores_)
        {
            
            score.erase(0, score.find(delimiter) + delimiter.length());
            if(game.compare(score.substr(0,score.find(delimiter))) == 0){
                score.erase(0, score.find(delimiter) + delimiter.length());
                int possibleBest = std::stoi(score);
                if(possibleBest > best) best = possibleBest;
            }


        }
        
        return best;
        
    }

    void Highscore::storeHighscore(std::string player, std::string level, int points){
        ModifyConfigValue(highscores_, add, player+"./."+level+"./."+std::to_string(points));
    }
    /* static std::string Highscore::getName(){
        std::string result;
        result = Highscore::name_;
        return result;
    }*/
}
